## ros-humble-webots-ros2-driver 2023.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(webots_ros2_driver)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)

# Check which ROS distribution is used, vision_msgs depends of that
if($ENV{ROS_DISTRO} MATCHES "humble")
  add_compile_definitions(HUMBLE)
elseif($ENV{ROS_DISTRO} MATCHES "iron")
  add_compile_definitions(IRON)
elseif($ENV{ROS_DISTRO} MATCHES "rolling")
  add_compile_definitions(ROLLING)
endif()

# ROS2 Packages
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(rosgraph_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(pluginlib REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(vision_msgs REQUIRED)
find_package(webots_ros2_msgs REQUIRED)
find_package(tinyxml2_vendor REQUIRED)
find_package(TinyXML2 REQUIRED)
find_package(yaml-cpp REQUIRED)
find_package(PythonLibs 3.10 EXACT REQUIRED)

add_custom_target(compile-lib-controller ALL
  COMMAND ${CMAKE_COMMAND} -E env "WEBOTS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/webots" make release -f Makefile > /dev/null 2>&1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/webots/src/controller
)

add_custom_target(compile-lib-vehicle ALL
  COMMAND ${CMAKE_COMMAND} -E env "WEBOTS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/webots" make release -f Makefile > /dev/null 2>&1
  DEPENDS compile-lib-controller
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/webots/projects/default/libraries/vehicle
)

add_custom_target(compile-generic-window ALL
  COMMAND ${CMAKE_COMMAND} -E env "WEBOTS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/webots" make release -f Makefile > /dev/null 2>&1
  DEPENDS compile-lib-controller
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/webots/resources/projects/libraries/generic_robot_window
)

set(WEBOTS_LIB_BASE webots/lib/controller)

include_directories(
  include
  webots/include/controller/c
  webots/include/controller/cpp
  ${PYTHON_INCLUDE_DIRS}
)

link_directories(${WEBOTS_LIB_BASE})

set(WEBOTS_LIB
  ${CMAKE_SHARED_LIBRARY_PREFIX}Controller${CMAKE_SHARED_LIBRARY_SUFFIX}
  ${CMAKE_SHARED_LIBRARY_PREFIX}CppController${CMAKE_SHARED_LIBRARY_SUFFIX}
  ${CMAKE_SHARED_LIBRARY_PREFIX}driver${CMAKE_SHARED_LIBRARY_SUFFIX}
  ${CMAKE_SHARED_LIBRARY_PREFIX}CppDriver${CMAKE_SHARED_LIBRARY_SUFFIX}
  ${CMAKE_SHARED_LIBRARY_PREFIX}car${CMAKE_SHARED_LIBRARY_SUFFIX}
  ${CMAKE_SHARED_LIBRARY_PREFIX}CppCar${CMAKE_SHARED_LIBRARY_SUFFIX}
)

ament_python_install_package(controller
  PACKAGE_DIR ${WEBOTS_LIB_BASE}/python/controller)

ament_python_install_package(vehicle
  PACKAGE_DIR ${WEBOTS_LIB_BASE}/python/vehicle)

ament_python_install_package(${PROJECT_NAME}
  PACKAGE_DIR ${PROJECT_NAME})

# Driver
set(CMAKE_INSTALL_RPATH "$ORIGIN/../controller") # Deprecated with new WebotsController node, remove with 2024.0.0
add_executable(driver
  src/Driver.cpp
  src/WebotsNode.cpp
  src/PythonPlugin.cpp
  src/plugins/Ros2SensorPlugin.cpp
  src/plugins/static/Ros2Lidar.cpp
  src/plugins/static/Ros2LED.cpp
  src/plugins/static/Ros2Pen.cpp
  src/plugins/static/Ros2Camera.cpp
  src/plugins/static/Ros2GPS.cpp
  src/plugins/static/Ros2RangeFinder.cpp
  src/plugins/static/Ros2DistanceSensor.cpp
  src/plugins/static/Ros2LightSensor.cpp
  src/plugins/static/Ros2Emitter.cpp
  src/plugins/static/Ros2Receiver.cpp
  src/plugins/static/Ros2Compass.cpp
  src/plugins/static/Ros2VacuumGripper.cpp
  src/utils/Math.cpp
  src/utils/Utils.cpp
)
ament_target_dependencies(driver
  rosgraph_msgs
  rclcpp
  pluginlib
  sensor_msgs
  std_msgs
  tf2_geometry_msgs
  tf2_ros
  vision_msgs
  webots_ros2_msgs
  tinyxml2_vendor
  TinyXML2
)
add_dependencies(driver
  compile-lib-vehicle
)
target_link_libraries(driver
  ${WEBOTS_LIB}
  ${PYTHON_LIBRARIES}
  yaml-cpp
)
install(
  DIRECTORY include/
  DESTINATION include
)
install(TARGETS driver
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Dynamic IMU
set(CMAKE_INSTALL_RPATH "$ORIGIN/controller") # Deprecated with new WebotsController node, remove with 2024.0.0
add_library(
  ${PROJECT_NAME}_imu
  SHARED
  src/plugins/dynamic/Ros2IMU.cpp
  src/plugins/Ros2SensorPlugin.cpp
  src/utils/Utils.cpp
)
ament_target_dependencies(${PROJECT_NAME}_imu
  rclcpp
  sensor_msgs
  webots_ros2_msgs
  pluginlib
  tf2_ros
)
add_dependencies(${PROJECT_NAME}_imu
  compile-lib-vehicle
)
target_link_libraries(${PROJECT_NAME}_imu
  ${WEBOTS_LIB}
)
install(TARGETS ${PROJECT_NAME}_imu
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

# Dynamic RGBD
set(CMAKE_INSTALL_RPATH "$ORIGIN/controller") # Deprecated with new WebotsController node, remove with 2024.0.0
add_library(
  ${PROJECT_NAME}_rgbd
  SHARED
  src/plugins/dynamic/Ros2RGBD.cpp
  src/plugins/Ros2SensorPlugin.cpp
  src/utils/Utils.cpp
)
ament_target_dependencies(${PROJECT_NAME}_rgbd
  rclcpp
  sensor_msgs
  pluginlib
  tf2_ros
)
add_dependencies(${PROJECT_NAME}_rgbd
  compile-lib-vehicle
)
target_link_libraries(${PROJECT_NAME}_rgbd
  ${WEBOTS_LIB}
)
install(TARGETS ${PROJECT_NAME}_rgbd
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

# libController
install(
  DIRECTORY webots/include/controller/c
  DESTINATION include/webots
)
install(
  DIRECTORY webots/include/controller/cpp
  DESTINATION include/webots
)
install(
  DIRECTORY ${WEBOTS_LIB_BASE}/
  DESTINATION lib/controller
  PATTERN "python*" EXCLUDE
  PATTERN "matlab" EXCLUDE
  PATTERN "*Controller*"
  PATTERN "*CppController*"
  PATTERN "*car*"
  PATTERN "*CppCar*"
  PATTERN "*driver*"
  PATTERN "*CppDriver*"
  PATTERN "*generic_robot_window*"
)

# Prevent pluginlib from using boost
target_compile_definitions(driver PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_compile_definitions(${PROJECT_NAME}_imu PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_compile_definitions(${PROJECT_NAME}_rgbd PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
pluginlib_export_plugin_description_file(${PROJECT_NAME} webots_ros2_imu.xml)
pluginlib_export_plugin_description_file(${PROJECT_NAME} webots_ros2_rgbd.xml)

# Install ROS 2 nodes
install(PROGRAMS ${PROJECT_NAME}/ros2_supervisor.py
  DESTINATION lib/${PROJECT_NAME}
)

# Install scripts
install(
  DIRECTORY scripts/
  DESTINATION share/${PROJECT_NAME}/scripts
)

# Install webots-controller script
install(
  PROGRAMS webots/webots-controller
  DESTINATION share/${PROJECT_NAME}/scripts
)

# Ament export
set(WEBOTS_LIB_PATH
  controller/${CMAKE_SHARED_LIBRARY_PREFIX}Controller${CMAKE_SHARED_LIBRARY_SUFFIX}
  controller/${CMAKE_SHARED_LIBRARY_PREFIX}CppController${CMAKE_SHARED_LIBRARY_SUFFIX}
  controller/${CMAKE_SHARED_LIBRARY_PREFIX}driver${CMAKE_SHARED_LIBRARY_SUFFIX}
  controller/${CMAKE_SHARED_LIBRARY_PREFIX}CppDriver${CMAKE_SHARED_LIBRARY_SUFFIX}
  controller/${CMAKE_SHARED_LIBRARY_PREFIX}car${CMAKE_SHARED_LIBRARY_SUFFIX}
  controller/${CMAKE_SHARED_LIBRARY_PREFIX}CppCar${CMAKE_SHARED_LIBRARY_SUFFIX}
  controller/${CMAKE_SHARED_LIBRARY_PREFIX}generic_robot_window${CMAKE_SHARED_LIBRARY_SUFFIX}
)

ament_export_include_directories(
  include
  include/webots/c
  include/webots/cpp
)
ament_export_dependencies(
  rclcpp
  rclpy
  sensor_msgs
  std_msgs
  tf2_geometry_msgs
  tf2_ros
  vision_msgs
  webots_ros2_msgs
  tinyxml2_vendor
  TinyXML2
)
ament_export_libraries(
  ${PROJECT_NAME}_imu
  ${PROJECT_NAME}_rgbd
  ${WEBOTS_LIB_PATH}
)
ament_package()

=== webots/src/controller/c/Makefile ===
# Copyright 1996-2023 Cyberbotics Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

ifeq ($(WEBOTS_HOME),)
WEBOTS_HOME_PATH = ../../..
else
null :=
space := $(null) $(null)
WEBOTS_HOME_PATH?=$(subst $(space),\ ,$(strip $(subst \,/,$(WEBOTS_HOME))))
endif

default:
	@echo "Type one of the following (OSTYPE is \""$(OSTYPE)"\"):"
	@echo "  make debug                 for debug (with gdb symbols)"
	@echo "  make profile               for profiling (with gprof information)"
	@echo "  make release               for finale release"
	@echo "  make clean                 remove build directory"
	@echo "  make count-lines           count the lines of code of C controller library"

count-lines:
	wc -l *.c* *.h*

include $(WEBOTS_HOME_PATH)/resources/Makefile.include

WEBOTS_DEPENDENCY_PATH ?= $(WEBOTS_HOME_PATH)/dependencies

ifeq ($(OSTYPE),darwin)
LIBCONTROLLER_VERSION := "$(shell cat $(WEBOTS_HOME_PATH)/Contents/Resources/version.txt)"
else
LIBCONTROLLER_VERSION := "$(shell cat $(WEBOTS_HOME_PATH)/resources/version.txt)"
endif

ifeq ($(OSTYPE),darwin)
CFLAGS      = -mmacosx-version-min=$(MACOSX_MIN_SDK_VERSION) -fpascal-strings -Wno-deprecated-declarations -I/Developer/Headers/FlatCarbon -Wall -fno-common -D LIBCONTROLLER_VERSION='$(LIBCONTROLLER_VERSION)'
INCLUDE     = -I$(WEBOTS_HOME_PATH)/include/controller/c -I$(WEBOTS_HOME_PATH)/include
LD_FLAGS    = -mmacosx-version-min=$(MACOSX_MIN_SDK_VERSION) -dynamiclib -install_name @rpath/Contents/lib/controller/libController.dylib -compatibility_version 1.0 -current_version 1.0.0
SHARED_LIBS = -lz
TARGET      = $(WEBOTS_CONTROLLER_LIB_PATH)/libController.dylib
CC          = gcc
endif

ifeq ($(OSTYPE),linux)
CFLAGS      = -fPIC -Wall -Wno-stringop-truncation -D LIBCONTROLLER_VERSION='$(LIBCONTROLLER_VERSION)'
INCLUDE     = -I$(WEBOTS_HOME_PATH)/include/controller/c -I$(WEBOTS_HOME_PATH)/include
LD_FLAGS    = -shared -Wl,-soname,libController.so
SHARED_LIBS = -lm -lpthread -ldl -lrt
TARGET      = $(WEBOTS_CONTROLLER_LIB_PATH)/libController.so
endif

ifeq ($(OSTYPE),windows)
CFLAGS      = -Wall -mwindows -frandom-seed=0 -D LIBCONTROLLER_VERSION='$(LIBCONTROLLER_VERSION)'
INCLUDE     = -I$(WEBOTS_HOME_PATH)/include/controller/c -I$(WEBOTS_HOME_PATH)/include -I/mingw64/include
LD_FLAGS    = -shared -mwindows --def Controller.def -lws2_32
PLATFORM    = win32
CC          = gcc
TARGET      = $(WEBOTS_CONTROLLER_LIB_PATH)/Controller.dll $(WEBOTS_CONTROLLER_LIB_PATH)/Controller.lib
endif

ifeq ($(MAKECMDGOALS),debug)
CFLAGS += -g
endif

ifeq ($(TREAT_WARNINGS_AS_ERRORS),1)
CFLAGS += -Werror
endif

ifeq ($(MAKECMDGOALS),profile)
CFLAGS += -pg -O3 -DNDEBUG
LD_FLAGS += -pg
endif

OBJDIR = build/$(MAKECMDGOALS)
ifneq (,$(findstring $(MAKECMDGOALS),debug profile release))
BUILD_PATH_SETUP := $(shell mkdir -p $(OBJDIR))
ifeq ($(OSTYPE),darwin)
BUILD_PATH_SETUP := $(shell mkdir -p $(OBJDIR)/x86_64 $(OBJDIR)/arm64)
endif
endif

ifdef EXTCONTROLLER
CFLAGS += -DEXTCONTROLLER
endif

ifeq ($(MAKECMDGOALS),release)
CFLAGS   += -O3 -DNDEBUG
ifneq ($(OSTYPE),darwin)
LD_FLAGS += -s
endif
endif

vpath %.o $(OBJDIR)
vpath %.c .

INCLUDE += -isystem $(WEBOTS_HOME_PATH)/src/stb

SOURCES=$(shell ls *.c)

OBJECTS=$(notdir $(SOURCES:.c=.o))

# clear out all suffixes for implicit rules to speed up Makefile
.SUFFIXES:
%:: %,v
%:: RCS/%,v
%:: RCS/%
%:: s.%
%:: SCCS/s.%

ifneq (,$(filter $(MAKECMDGOALS),debug release profile)) # if $(MAKECMDGOALS) is either of those
-include $(addprefix $(OBJDIR)/,$(notdir $(SOURCES:.c=.d)))
endif

debug profile release: $(TARGET)

ifeq ($(OSTYPE),windows)

MINGW64_OBJECTS = $(addprefix $(OBJDIR)/, $(OBJECTS))

$(WEBOTS_CONTROLLER_LIB_PATH)/Controller.dll: $(MINGW64_OBJECTS) Controller.def
	@echo "# linking  "$@
	@echo "# linking  "$(WEBOTS_CONTROLLER_LIB_PATH)"/libController.a"
	@$(CC) -o $@ $(addprefix $(OBJDIR)/, $(OBJECTS)) $(LD_FLAGS) -Wl,--out-implib,$(WEBOTS_CONTROLLER_LIB_PATH)/libController.a

$(WEBOTS_CONTROLLER_LIB_PATH)/Controller.lib: $(WEBOTS_CONTROLLER_LIB_PATH)/Controller.dll Controller.def
ifeq ($(VISUAL_STUDIO_PATH),)
	@$(ECHO) "# \033[0;33m'VISUAL_STUDIO_PATH' not set, skipping Controller.lib\033[0m"
else
	@echo "# creating "$@
	@PATH="$(VISUAL_STUDIO_PATH)/BuildTools/VC/Tools/MSVC/14.16.27023/bin/Hostx64/x64":$PATH lib /machine:X64 /def:Controller.def /out:Controller.lib > /dev/null
	@mv Controller.lib "$(WEBOTS_CONTROLLER_LIB_PATH)"
	@rm Controller.exp
endif

endif

ifeq ($(OSTYPE),darwin)
X86_64_OBJECTS = $(addprefix $(OBJDIR)/x86_64/, $(OBJECTS))
ARM64_OBJECTS = $(addprefix $(OBJDIR)/arm64/, $(OBJECTS))

$(TARGET): $(OBJDIR)/x86_64/libController.dylib $(OBJDIR)/arm64/libController.dylib
	@echo "# creating fat binary: $$"\(WEBOTS_HOME\)/lib/controller/libController.dylib
	@lipo -create -output $(TARGET) $(OBJDIR)/x86_64/libController.dylib $(OBJDIR)/arm64/libController.dylib
	@chmod a-x $@
	@codesign -s - $@

$(OBJDIR)/x86_64/libController.dylib: $(X86_64_OBJECTS)
	@echo "# linking "$@" (x86_64)"
	@$(CC) $(LD_FLAGS) -target x86_64-apple-macos11 -o $@ $(X86_64_OBJECTS) $(SHARED_LIBS)
	@chmod a-x $@

$(OBJDIR)/arm64/libController.dylib: $(ARM64_OBJECTS)
	@echo "# linking "$@" (arm64)"
	@$(CC) $(LD_FLAGS) -target arm64-apple-macos11 -o $@ $(ARM64_OBJECTS) $(SHARED_LIBS)
	@chmod a-x $@

endif

ifeq ($(OSTYPE),linux)
$(TARGET): $(OBJECTS)
	@echo "# linking "$@
	@$(CC) $(LD_FLAGS) -o $(TARGET) $(addprefix $(OBJDIR)/, $(OBJECTS)) $(SHARED_LIBS)
	@chmod a-x $(TARGET)
endif

$(OBJDIR)/robot.o: $(WEBOTS_HOME_PATH)/resources/version.txt

$(OBJDIR)/%.o:%.c
	@echo "# compiling "$<
	@$(CC) -c $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDE) $< -o $@

$(OBJDIR)/arm64/%o:%c
	@echo "# compiling "$<" (arm64)"
	@$(CC) -c -target arm64-apple-macos11 $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDE) $< -o $(OBJDIR)/arm64/$(notdir $@)

$(OBJDIR)/x86_64/%o:%c
	@echo "# compiling "$<" (x86_64)"
	@$(CC) -c -target x86_64-apple-macos11 $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDE) $< -o $(OBJDIR)/x86_64/$(notdir $@)

$(OBJDIR)/%.d:%.c
	@echo "# updating "$(notdir $@)
	@echo $(basename $(OBJDIR)/$(notdir $@)).o: $(basename $@).d > $(OBJDIR)/$(notdir $@)
	@printf "%s" "$(OBJDIR)/" >> $(OBJDIR)/$(notdir $@)
	@$(CC) $(CFLAGS) -MM -w $(INCLUDE) $< >> $(OBJDIR)/$(notdir $@)

FILES_TO_REMOVE = $(TARGET)
FILES_TO_REMOVE += $(WEBOTS_CONTROLLER_LIB_PATH)/libController.a
FILES_TO_REMOVE += $(WEBOTS_CONTROLLER_LIB_PATH)/libController.lib

=== webots/src/controller/matlab/Makefile ===
# Copyright 1996-2023 Cyberbotics Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

ifeq ($(WEBOTS_HOME),)
WEBOTS_HOME_PATH = ../../..
else
null :=
space := $(null) $(null)
WEBOTS_HOME_PATH?=$(subst $(space),\ ,$(strip $(subst \,/,$(WEBOTS_HOME))))
endif

include $(WEBOTS_HOME_PATH)/resources/Makefile.os.include

PYTHON_OK := $(shell which python3)
release debug profile:
	@echo "# generating matlab"
ifeq ('$(PYTHON_OK)','')
	@$(ECHO) "# \033[0;33mUnable to find python3, skipping matlab API\033[0m"
else
	$(shell python3 mgenerate.py;)
endif

clean:
	for name in $$(cat $(WEBOTS_HOME_PATH)/lib/controller/matlab/.gitignore); do rm -f $(WEBOTS_HOME_PATH)/lib/controller/matlab/$$name; done;

=== webots/projects/default/libraries/vehicle/Makefile ===
# Copyright 1996-2023 Cyberbotics Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

null :=
space := $(null) $(null)
WEBOTS_HOME_PATH?=$(subst $(space),\ ,$(strip $(subst \,/,$(WEBOTS_HOME))))
include $(WEBOTS_HOME_PATH)/resources/Makefile.os.include

.PHONY: release debug profile clean c/car c/driver cpp/car cpp/driver python java

release debug profile clean: java python

java: cpp/driver cpp/car
	+@echo "# make" $(MAKECMDGOALS) $@
	+@make -s -C $@ $(MAKECMDGOALS)

cpp/car: cpp/driver c/car
	+@echo "# make" $(MAKECMDGOALS) $@
	+@make -s -C $@ $(MAKECMDGOALS)

cpp/driver: c/driver
	+@echo "# make" $(MAKECMDGOALS) $@
	+@make -s -C $@ $(MAKECMDGOALS)

c/driver: c/car
	+@echo "# make" $(MAKECMDGOALS) $@
	+@make -s -C $@ $(MAKECMDGOALS)

c/car:
	+@echo "# make" $(MAKECMDGOALS) $@
	+@make -s -C c/car $(MAKECMDGOALS)

=== webots/resources/projects/libraries/generic_robot_window/Makefile ===
# Copyright 1996-2023 Cyberbotics Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Webots Makefile system
#
# You may add some variable definitions hereafter to customize the build process
# See documentation in $(WEBOTS_HOME_PATH)/resources/Makefile.include

WEBOTS_LIBRARY = 1
C_SOURCES = $(wildcard *.c)

null :=
space := $(null) $(null)
WEBOTS_HOME_PATH?=$(subst $(space),\ ,$(strip $(subst \,/,$(WEBOTS_HOME))))
include $(WEBOTS_HOME_PATH)/resources/Makefile.include

=== webots/projects/default/libraries/vehicle/java/Makefile ===
# Copyright 1996-2023 Cyberbotics Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

null :=
space := $(null) $(null)
WEBOTS_HOME_PATH?=$(subst $(space),\ ,$(strip $(subst \,/,$(WEBOTS_HOME))))
WEBOTS_HOME_PATH_NO_ESCAPE=$(subst \,/,$(WEBOTS_HOME))
include $(WEBOTS_HOME_PATH)/resources/Makefile.os.include

WEBOTS_LIBRARY = 1
MODULE_NAME = vehicle

INTERFACE = $(MODULE_NAME).i
SOURCE_HEADERS = $(substr $(WEBOTS_HOME_PATH_NO_ESCAPE),$(WEBOTS_HOME_PATH),$(wildcard $(WEBOTS_HOME_PATH)/include/controller/cpp/webots/*.hpp))
JAVA_FILES = Driver.java Car.java vehicle.java vehicleJNI.java

WRAPPER = $(MODULE_NAME).cpp
WRAPPER_OBJECT = $(WRAPPER:.cpp=.o)
JAR = $(WEBOTS_CONTROLLER_LIB_PATH)/java/$(MODULE_NAME).jar
INCLUDES = -I$(WEBOTS_HOME_PATH)/include/controller/c/ -I$(WEBOTS_HOME_PATH)/include/controller/cpp/

SWIG_OUTPUT  = output
MODULE_PATH  = com/cyberbotics/webots/controller/vehicle
JAVA_SOURCES = $(addprefix $(SWIG_OUTPUT)/,$(JAVA_FILES))

SWIG_EXISTS = $(shell which swig 2> /dev/null)

ifeq ($(OSTYPE),linux)
JAVA_INCLUDES = -I"$(JAVA_HOME)/include" -I"$(JAVA_HOME)/include/linux"
CFLAGS2       = -c -Wall -Wno-unused-function -fPIC
LIBRARY       = $(WEBOTS_CONTROLLER_LIB_PATH)/java/libvehicle.so
endif

ifeq ($(OSTYPE),windows)
JAVA_INCLUDES = -I"$(JAVA_HOME)/include" -I"$(JAVA_HOME)/include/win32"
CFLAGS2       = -c -Wall -Wno-unused-function -O
LIBRARY       = $(WEBOTS_CONTROLLER_LIB_PATH)/java/vehicle.dll
endif

ifeq ($(OSTYPE),darwin)
WRAPPER_OBJECT_ARM64 = $(WRAPPER:.cpp=-arm64.o)
WRAPPER_OBJECT_X86_64 = $(WRAPPER:.cpp=-x86_64.o)
JAVA_INCLUDES = -I"$(JAVA_HOME)/include" -I"$(JAVA_HOME)/include/darwin" -I"$(MACOSX_SDK_PATH)/System/Library/Frameworks/JavaVM.framework/Versions/Current/Headers"
CFLAGS1 = -isysroot $(MACOSX_SDK_PATH) -mmacosx-version-min=$(MACOSX_MIN_SDK_VERSION) -stdlib=libc++ -Wl,-rpath,@loader_path/../../..
CFLAGS2 = -c -Wall -isysroot $(MACOSX_SDK_PATH) -mmacosx-version-min=$(MACOSX_MIN_SDK_VERSION) -stdlib=libc++ -Wno-unused-function
LIBRARY = $(WEBOTS_CONTROLLER_LIB_PATH)/java/libvehicle.jnilib
endif

LIB += -L"$(WEBOTS_CONTROLLER_LIB_PATH)" -lCppController -lCppCar -lCppDriver

.PHONY: JAVA_CLASSES all

# rules
ifeq ($(SWIG_EXISTS),)
all release debug profile:
	@$(ECHO) "# \033[0;33mSWIG not installed, skipping Java API\033[0m"
else ifeq ($(JAVA_HOME),)
all release debug profile:
	@$(ECHO) "# \033[0;33mJava not installed or 'JAVA_HOME' not set, skipping Java API\033[0m"
else
all release debug profile: $(JAR) $(LIBRARY)

$(JAR): JAVA_CLASSES
	@mkdir -p $(WEBOTS_CONTROLLER_LIB_PATH)/java
	@jar cfv "$@" $(MODULE_PATH)/*.class > /dev/null

JAVA_CLASSES: $(JAVA_SOURCES)
	@javac --release 8 -classpath $(WEBOTS_CONTROLLER_LIB_PATH)/java/Controller.jar $(JAVA_SOURCES) -d .

$(JAVA_SOURCES): $(WRAPPER)

$(WRAPPER): $(INTERFACE) $(SOURCE_HEADERS)
	@mkdir -p $(SWIG_OUTPUT)
	@swig -c++ -java -package $(subst /,.,$(MODULE_PATH)) -outdir $(SWIG_OUTPUT) -I$(WEBOTS_HOME_PATH)/src/controller/java/ $(INCLUDES) -o $@ $<

$(WRAPPER_OBJECT): $(WRAPPER)
	@$(CXX) $(CFLAGS2) $(INCLUDES) $(JAVA_INCLUDES) $< -o "$@"

$(WRAPPER_OBJECT_ARM64): $(WRAPPER)
	@$(CXX) -target arm64-apple-macos11 $(CFLAGS2) $(INCLUDES) $(JAVA_INCLUDES) $< -o "$@"

$(WRAPPER_OBJECT_X86_64): $(WRAPPER)
	@$(CXX) -target x86_64-apple-macos11 $(CFLAGS2) $(INCLUDES) $(JAVA_INCLUDES) $< -o "$@"

%.so: $(WRAPPER_OBJECT)
	@mkdir -p $(WEBOTS_CONTROLLER_LIB_PATH)/java
	@$(CXX) -shared $< $(LIB) -o "$@"

%.dll: $(WRAPPER_OBJECT)
	@mkdir -p $(WEBOTS_CONTROLLER_LIB_PATH)/java
	@$(CXX) -shared -mwindows -Wl,--add-stdcall-alias -Wl,--enable-auto-import -O -lm $< $(LIB) -o "$@"

%.jnilib: $(WRAPPER_OBJECT_ARM64) $(WRAPPER_OBJECT_X86_64)
	@$(CXX) -target arm64-apple-macos11 $(CFLAGS1) -bundle $(WRAPPER_OBJECT_ARM64) $(LIB) -o lib$(MODULE_NAME)-arm64.jnilib
	@$(CXX) -target x86_64-apple-macos11 $(CFLAGS1) -bundle $(WRAPPER_OBJECT_X86_64) $(LIB) -o lib$(MODULE_NAME)-x86_64.jnilib
	@mkdir -p $(WEBOTS_CONTROLLER_LIB_PATH)/java
	@lipo -create -output "$@" lib$(MODULE_NAME)-arm64.jnilib lib$(MODULE_NAME)-x86_64.jnilib
	@codesign -s - "$@"
endif

clean:
	@rm -fr com $(SWIG_OUTPUT) $(JAR) $(WRAPPER) $(LIBRARY) *.o *.jnilib
	@rm -d $(WEBOTS_CONTROLLER_LIB_PATH)/java > /dev/null 2>&1 || :

=== webots/projects/default/libraries/vehicle/c/car/Makefile ===
# Copyright 1996-2023 Cyberbotics Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

null :=
space := $(null) $(null)
WEBOTS_HOME_PATH?=$(subst $(space),\ ,$(strip $(subst \,/,$(WEBOTS_HOME))))
include $(WEBOTS_HOME_PATH)/resources/Makefile.os.include

WEBOTS_LIBRARY = 1
C_SOURCES = $(wildcard src/*.c)

LIBRARIES = -L$(WEBOTS_CONTROLLER_LIB_PATH) -lController
MAIN_TARGET = $(LIB_PREFIX)car$(SHARED_LIB_EXTENSION)
LFLAGS = -shared -Wl,-rpath,'$$ORIGIN'

ifeq ($(OSTYPE),linux)
LINK_DEPENDENCIES = $(WEBOTS_CONTROLLER_LIB_PATH)/libController.so
endif

ifeq ($(OSTYPE),darwin)
LINK_DEPENDENCIES = $(WEBOTS_CONTROLLER_LIB_PATH)/libController.dylib
endif

ifeq ($(OSTYPE),windows)
LINK_DEPENDENCIES = $(WEBOTS_CONTROLLER_LIB_PATH)/Controller.dll
endif

include $(WEBOTS_HOME_PATH)/resources/Makefile.include

=== debian/changelog ===
ros-humble-webots-ros2-driver (2023.1.1-2jammy) jammy; urgency=high

  * Fixed RangeFinder activation to also check for point cloud subscriptions.
  * Added component remapping parameter to rename PROTO components.
  * Added deprecation message when declaring driver node in launch file.
  * Added animation_{start,stop}_recording services to Ros2Supervisor node.
  * Added /Ros2Supervisor namespace to Ros2Supervisor node.
  * Fixed Python plugin termination on SIGINT call or simulation ends.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 10 Jul 2023 22:00:00 -0000

ros-humble-webots-ros2-driver (2023.1.0-2jammy) jammy; urgency=high

  * Added Ros2Pen static plugin.
  * Added parameters to rename Camera and RangeFinder topics.
  * Added new WebotsController node to launch robot controller plugins.
  * Added compilation of the generic robot window library.
  * Default to canonical topic name and fix camera_info stamp in Ros2Camera, Ros2RangeFinder.
  * Added VacuumGripper device support.

 -- Cyberbotics <support@cyberbotics.com>  Wed, 28 Jun 2023 22:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.4-2jammy) jammy; urgency=high

  * Fixed vertical field of view in static RangeFinder plugin.
  * Added support for painted point clouds.
  * Added custom handler to start nodes when Webots is ready.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 22 May 2023 22:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.3-2jammy) jammy; urgency=high

  * Adding port, stream type parameters to webots_laucher
  * Copying .wbproj when launching a webots world via webots_launcher
  * Added Emitter and Receiver support
  * Changed undefined Lidar frequency to the default from the .proto file
  * Added Compass support

 -- Cyberbotics <support@cyberbotics.com>  Tue, 11 Apr 2023 22:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.2-2jammy) jammy; urgency=high

  * Fixed the spawn of URDF robots in WSL and macOS when using full path.
  * Fixed relative assets in macOS.
  * Added Ros2Supervisor creation.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 06 Feb 2023 23:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.1-2jammy) jammy; urgency=high

  * Fixed relative assets in WSL.

 -- Cyberbotics <support@cyberbotics.com>  Wed, 04 Jan 2023 23:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.0-2jammy) jammy; urgency=high

  * Add support for the new Python API of Webots R2023a
  * Convert C++ controller API functions to C
  * Replace libController submodule by commited source files

 -- Cyberbotics <support@cyberbotics.com>  Tue, 29 Nov 2022 23:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.4-2jammy) jammy; urgency=high

  * Fix the camera focal length in the CameraInfo topic.
  * Update the calculation of CameraRecognitionObject messages to the RDF convention of R2022b.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 17 Nov 2022 23:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.3-2jammy) jammy; urgency=high

  * Added macOS support.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 01 Nov 2022 23:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.2-2jammy) jammy; urgency=high

  * Fix issue where relatively defined PROTO were not found.
  * Added WSL support.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 20 Oct 2022 22:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.1-2jammy) jammy; urgency=high

  * Simplified the detection of Webots installation folder.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 10 Oct 2022 22:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.0-2jammy) jammy; urgency=high

  * Added an URDF importer feature to spawn robots from URDF files.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 22 Sep 2022 22:00:00 -0000

ros-humble-webots-ros2-driver (1.2.3-2jammy) jammy; urgency=high

  * Add option to set 'robot_description' parameter for 'robot_state_publisher' node.
  * Fix recognition camera.
  * Add a 'PointCloud2' publisher for the 'RangeFinder' device.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 29 May 2022 22:00:00 -0000

ros-humble-webots-ros2-driver (1.2.2-2jammy) jammy; urgency=high

  * Fix the Supervisor API access from plugins.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 18 Jan 2022 23:00:00 -0000

ros-humble-webots-ros2-driver (1.2.1-2jammy) jammy; urgency=high

  * Fix link error for 'webots_ros2_control' on macOS.
  * Fix lidar device according to FLU convention.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 09 Jan 2022 23:00:00 -0000

ros-humble-webots-ros2-driver (1.2.0-2jammy) jammy; urgency=high

  * Adapt the worlds to the new R2022a FLU convention.
  * Remove a double webots_ros2_driver header installation.
  * Add the publication of the 'gps/speed_vector' topic to the GPS ROS 2 device.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 20 Dec 2021 23:00:00 -0000

ros-humble-webots-ros2-driver (1.1.2-2jammy) jammy; urgency=high

  * Adapted the 'webots_ros2_driver' package to be also a python alternative to the 'webots_ros2_core' package.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 02 Nov 2021 23:00:00 -0000

ros-humble-webots-ros2-driver (1.1.0-2jammy) jammy; urgency=high

  * Initial version

 -- Cyberbotics <support@cyberbotics.com>  Sun, 18 Jul 2021 22:00:00 -0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-webots-ros2-driver//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-webots-ros2-driver 2023.1.2

=== debian/changelog ===
ros-humble-webots-ros2-driver (2023.1.2-3bookworm) bookworm; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Cyberbotics <support@cyberbotics.com>  Fri, 16 Aug 2024 06:16:36 -0000

ros-humble-webots-ros2-driver (2023.1.1-3bookworm) bookworm; urgency=high

  * Fixed RangeFinder activation to also check for point cloud subscriptions.
  * Added component remapping parameter to rename PROTO components.
  * Added deprecation message when declaring driver node in launch file.
  * Added animation_{start,stop}_recording services to Ros2Supervisor node.
  * Added /Ros2Supervisor namespace to Ros2Supervisor node.
  * Fixed Python plugin termination on SIGINT call or simulation ends.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 10 Jul 2023 16:00:00 -0000

ros-humble-webots-ros2-driver (2023.1.0-3bookworm) bookworm; urgency=high

  * Added Ros2Pen static plugin.
  * Added parameters to rename Camera and RangeFinder topics.
  * Added new WebotsController node to launch robot controller plugins.
  * Added compilation of the generic robot window library.
  * Default to canonical topic name and fix camera_info stamp in Ros2Camera, Ros2RangeFinder.
  * Added VacuumGripper device support.

 -- Cyberbotics <support@cyberbotics.com>  Wed, 28 Jun 2023 16:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.4-3bookworm) bookworm; urgency=high

  * Fixed vertical field of view in static RangeFinder plugin.
  * Added support for painted point clouds.
  * Added custom handler to start nodes when Webots is ready.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 22 May 2023 16:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.3-3bookworm) bookworm; urgency=high

  * Adding port, stream type parameters to webots_laucher
  * Copying .wbproj when launching a webots world via webots_launcher
  * Added Emitter and Receiver support
  * Changed undefined Lidar frequency to the default from the .proto file
  * Added Compass support

 -- Cyberbotics <support@cyberbotics.com>  Tue, 11 Apr 2023 16:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.2-3bookworm) bookworm; urgency=high

  * Fixed the spawn of URDF robots in WSL and macOS when using full path.
  * Fixed relative assets in macOS.
  * Added Ros2Supervisor creation.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 06 Feb 2023 16:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.1-3bookworm) bookworm; urgency=high

  * Fixed relative assets in WSL.

 -- Cyberbotics <support@cyberbotics.com>  Wed, 04 Jan 2023 16:00:00 -0000

ros-humble-webots-ros2-driver (2023.0.0-3bookworm) bookworm; urgency=high

  * Add support for the new Python API of Webots R2023a
  * Convert C++ controller API functions to C
  * Replace libController submodule by commited source files

 -- Cyberbotics <support@cyberbotics.com>  Tue, 29 Nov 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.4-3bookworm) bookworm; urgency=high

  * Fix the camera focal length in the CameraInfo topic.
  * Update the calculation of CameraRecognitionObject messages to the RDF convention of R2022b.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 17 Nov 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.3-3bookworm) bookworm; urgency=high

  * Added macOS support.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 01 Nov 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.2-3bookworm) bookworm; urgency=high

  * Fix issue where relatively defined PROTO were not found.
  * Added WSL support.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 20 Oct 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.1-3bookworm) bookworm; urgency=high

  * Simplified the detection of Webots installation folder.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 10 Oct 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (2022.1.0-3bookworm) bookworm; urgency=high

  * Added an URDF importer feature to spawn robots from URDF files.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 22 Sep 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (1.2.3-3bookworm) bookworm; urgency=high

  * Add option to set 'robot_description' parameter for 'robot_state_publisher' node.
  * Fix recognition camera.
  * Add a 'PointCloud2' publisher for the 'RangeFinder' device.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 29 May 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (1.2.2-3bookworm) bookworm; urgency=high

  * Fix the Supervisor API access from plugins.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 18 Jan 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (1.2.1-3bookworm) bookworm; urgency=high

  * Fix link error for 'webots_ros2_control' on macOS.
  * Fix lidar device according to FLU convention.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 09 Jan 2022 16:00:00 -0000

ros-humble-webots-ros2-driver (1.2.0-3bookworm) bookworm; urgency=high

  * Adapt the worlds to the new R2022a FLU convention.
  * Remove a double webots_ros2_driver header installation.
  * Add the publication of the 'gps/speed_vector' topic to the GPS ROS 2 device.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 20 Dec 2021 16:00:00 -0000

ros-humble-webots-ros2-driver (1.1.2-3bookworm) bookworm; urgency=high

  * Adapted the 'webots_ros2_driver' package to be also a python alternative to the 'webots_ros2_core' package.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 02 Nov 2021 16:00:00 -0000

ros-humble-webots-ros2-driver (1.1.0-3bookworm) bookworm; urgency=high

  * Initial version

 -- Cyberbotics <support@cyberbotics.com>  Sun, 18 Jul 2021 16:00:00 -0000

=== debian/control ===
Source: ros-humble-webots-ros2-driver
Section: misc
Priority: optional
Maintainer: Cyberbotics <support@cyberbotics.com>
Build-Depends: debhelper (>= 9.0.0), libyaml-cpp-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-python, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-geometry-msgs, ros-humble-pluginlib, ros-humble-python-cmake-module, ros-humble-rclcpp, ros-humble-rclpy, ros-humble-ros-environment, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-tf2-geometry-msgs, ros-humble-tf2-ros, ros-humble-tinyxml2-vendor, ros-humble-vision-msgs, ros-humble-webots-ros2-importer, ros-humble-webots-ros2-msgs, ros-humble-ros-workspace
Homepage: http://wiki.ros.org/webots_ros2
Standards-Version: 3.9.2

Package: ros-humble-webots-ros2-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-cpp-dev, ros-humble-geometry-msgs, ros-humble-pluginlib, ros-humble-rclcpp, ros-humble-rclpy, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-tf2-geometry-msgs, ros-humble-tf2-ros, ros-humble-tinyxml2-vendor, ros-humble-vision-msgs, ros-humble-webots-ros2-importer, ros-humble-webots-ros2-msgs, ros-humble-ros-workspace
Description: Implementation of the Webots - ROS 2 interface

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-webots-ros2-driver//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-webots-ros2-driver//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-webots-ros2-driver//opt/ros/humble/opt/webots_ros2_driver/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
